#ifndef NGLOBAL_H
#define NGLOBAL_H

    #include "define.h"

    typedef struct ROM_typ
    {
      WORD valid;
      unsigned short is_compressed;   // 12=uncompressed, 13 = compressed
      unsigned short unknown;                 // always 0x40
      DWORD Clockrate;
      DWORD Program_Counter;
      DWORD Release;
      DWORD CRC1;
      DWORD CRC2;
      QWORD filler1;
      BYTE Image_Name[20];
      short int filler2[7];
      BYTE Manu_ID;
      WORD Cart_ID;
      BYTE Country_Code;
      short int filler3;
      DWORD BOOTCODE;
    } ROMHeader;

    struct main_typ
    {
      QWORD regs[0x20];
    };

    struct COP0_typ
    {
      QWORD regs[0x20];
    };

    struct COP1_typ
    {
      DWORD regs[0x20]; // DAMN YOU BPOINT!
    };


    struct regs_typ
    {
      DWORD PC;
      DWORD REAL_PC;
      QWORD MultHI;
      QWORD MultLO;
      struct main_typ main;
      struct COP0_typ cop0;
      struct COP1_typ cop1;
    } ;

#endif
