/* NINCEST 64
** (c)1998-2000 by Marius Dumitrean P. and Chris Le Blond
*/
#ifndef DEBUG_H_
#define DEBUG_H_

    #include <ctype.h>
    #include <stdarg.h>

    #include "r4300.h"
    #include "memhand.h"

    typedef struct break_typ
    {
      DWORD data;                                           // Data
      BYTE used;
    } breaks;

    struct counters_typ
    {
      WORD break_addr;
      WORD break_mw;
      WORD break_mr;
      WORD break_op;
    };

    typedef struct debug_typ_
    {
      struct counters_typ counters;
      BYTE info_nec;                                // Will debugging info be
                                                    // necessary next opcode?
                                                    // 1 yes, 0 no
      DWORD break_addr;                             // break address
      DWORD break_mw;                               // break memory write
      DWORD break_mr;                               // break memory read
      signed short int break_op;                    // break when
                                                    // break_op == r4300_opcode()
      BYTE show_regs;                               // show regs after instruction
                                                    // has been run
      BYTE cont;                                    // continue
    }debug_typ;
    extern debug_typ debug;
    extern unsigned short int jump_cnt;
    extern DWORD JUMPS[0xffff];

    void get_number ( char *string );
    unsigned char parse_debug_input ( char *string );
    void get_debug_input ( const char *text, ... );
    void stop_cont ( void );

#endif
