#ifdef GP2X
    #include <unistd.h>
    #include "minimal.h"
#endif
#include "main.h"

int main(int argc, char **argv)
{
    CreateLog();
    WriteLog("Nincest64 - LOG");
    PrintInfos();

    ramHack();
    mmuHack();
    setCpuClock(266);

    if(LoadRom("stars.v64") == -1)
        return 1;

#ifndef DEBUG
  #ifdef VIDEO
        InitVideo();
  #endif
#endif

    Emulate();

    CloseRom();
    CloseLog();

    closeMmuHack();
#ifdef GP2X
    gp2x_deinit();
#endif

	return 0;
}
