#ifndef UTILS_H
#define UTILS_H

    #include <stdio.h>
    #include <stdlib.h>
#ifdef GP2X
    #include <fcntl.h>
    #include <sys/mman.h>
    #include <linux/fb.h>
    #include <unistd.h>
    #include <stropts.h>
    #define SYS_CLK_FREQ 7372800
#endif

    #include "define.h"

    extern void SwapBytes(WORD *var);
    extern void SwapWords(DWORD *var);
    extern void PrintInfos();

    extern int mmuHack();
    extern void setCpuClock(unsigned int mhz);
    extern void ramHack();
    extern void closeMmuHack();

#endif

